import { Block, Entity, ScoreboardIdentity, ScoreboardObjective, world } from "@minecraft/server";
import { prefix, logobj } from "../utils";
import { EntityBase } from "./entity_base";

const scName = "en:bc";

export class BarrelEntity extends EntityBase {
    static readonly NAMESPACE = prefix("barrel");

    public scoreboard: ScoreboardObjective = world.scoreboard.getObjective(scName);
    public capacity: number;

    static Registry(): void {
        world.events.entitySpawn.subscribe(({ entity }) => {
            if (entity.typeId != BarrelEntity.NAMESPACE) return;
            if (entity.scoreboard) return;
            if (!world.scoreboard.getObjective(scName)) {
                world.scoreboard.addObjective(scName, scName);
            }
            entity.runCommandAsync(`scoreboard players set @s ${scName} 0`);
        })
    }

    constructor(block: Block, entity: Entity = undefined) {
        super(block, entity);
        try {
            if (!this.scoreboard) this.scoreboard = world.scoreboard.addObjective(scName, scName);
            let eScoreboard: ScoreboardIdentity = this.entity.scoreboard;
            if (eScoreboard) {
                this.capacity = this.scoreboard.getScore(eScoreboard);
            }
        } catch (e) {
            // world.say(e + "\n" + e.stack)
        }
    }
}