import { MinecraftBlockTypes, world } from "@minecraft/server";
import { prefix, splitNamespace } from "../utils";

export class Silkworm {

    static readonly itemNamespace = prefix("silkworm");

    static Registry() {
        world.events.itemUseOn.subscribe(async ({ item, source, blockLocation }) => {
            if (item.typeId != Silkworm.itemNamespace) return;
            let block = source.dimension.getBlock(blockLocation);
            if (block.isWaterlogged) return;
            let splited = splitNamespace(block.typeId);
            let blockType: string;
            if (splited.isVanilla) {
                switch (splited.last) {
                    case "leaves":
                        // @ts-ignored
                        blockType = prefix(`infesting_leaves_${block.permutation.getProperty("old_leaf_type").value}`);
                        break;
                    case "leaves2":
                        // @ts-ignored
                        blockType = prefix(`infesting_leaves_${block.permutation.getProperty("new_leaf_type").value}`);
                        break;
                    // case "mangrove_leaves":
                    //     break;
                    // case "azalea_leaves":
                    //     break;
                    // case "azalea_leaves_flowered":
                    //     break;
                }
            }
            if (blockType) source.runCommandAsync(`clear @s[m=!creative] ${item.typeId} ${item.data} 1`).finally(() => {
                block.setType(MinecraftBlockTypes.get(blockType));
            });
        });
    }
}