import { MinecraftBlockTypes, world } from "@minecraft/server";
import { prefix, splitNamespace } from "../utils";

export class SporeNyliumCrimson {

    static readonly itemNamespace = prefix("spore_nylium_crimson");

    static Registry() {
        world.events.itemUseOn.subscribe(async ({ item, source, blockLocation }) => {
            if (item.typeId != SporeNyliumCrimson.itemNamespace) return;
            let block = source.dimension.getBlock(blockLocation);
            let splited = splitNamespace(block.typeId);
            let blockType: string;
            if (splited.isVanilla) {
                switch (splited.last) {
                    case "dirt":
                        blockType = "minecraft:crimson_nylium";
                        break;
                }
            }
            if (blockType) source.runCommandAsync(`clear @s[m=!creative] ${item.typeId} ${item.data} 1`).finally(() => {
                block.setType(MinecraftBlockTypes.get(blockType));
            });
        });
    }
}