import {
    world,
    MinecraftBlockTypes,
    ItemStack,
    Player,
    ItemTypes,
    Block,
    BlockPermutation,
    EntityItemComponent,
    EntitySpawnEvent,
    EntityInventoryComponent,
    IEntityComponent
} from '@minecraft/server'
import { Barrel } from './block/barrel'
import { Silkworm } from './item/silkworm'
import { GrassSeeds } from './item/grass_seeds'
import { SporeMycelium } from './item/spore_mycelium'
import { SporeNyliumCrimson } from './item/spore_nylium_crimson'
import { SporeNyliumWarped } from './item/spore_nylium_warped'
import { Sieve } from './block/sieve'
import { BarrelEntity } from './entity/barrel'
import { Crook } from './item/crook'
import { Crucible } from './block/crucible'
import { CrucibleEntity } from './entity/crucible'
import { Hammer } from './item/hammer'

const itemRegistry = [
    Silkworm,
    GrassSeeds,
    SporeMycelium,
    SporeNyliumCrimson,
    SporeNyliumWarped,
    Crook,
    Hammer,
]

const blockRegistry = [
    Sieve,
    Barrel,
    Crucible,
]

const entityRegistry = [
    BarrelEntity,
    CrucibleEntity,
]

let registry = [...itemRegistry, ...blockRegistry, ...entityRegistry]

registry.forEach(o => o.Registry());

// function onBreakByHammer({ player, block, brokenBlock }: { player: Player; block: Block; brokenBlock: BlockPermutation }) {
//     let allowedBlocks = [
//         MinecraftBlockTypes.cobblestone.id,
//         MinecraftBlockTypes.gravel.id,
//         MinecraftBlockTypes.sand.id,
//         MinecraftBlockTypes.netherrack.id,
//         MinecraftBlockTypes.endStone.id,
//     ]
//     if (!allowedBlocks.includes(brokenBlock.type.id)) return
//     let slotid = player.selectedSlot
//     let component = player.getComponent("inventory")
//     if (!(component instanceof EntityInventoryComponent)) return
//     let container = component.container
//     if (!container) return
//     let item = container.getItem(slotid)
//     if (!item) return
//     if (!item.typeId.includes(prefix("hammer"))) return

//     new Promise((resolve, _) => {
//         resolve(world.events.entitySpawn.subscribe(ev => {
//             let e = ev.entity
//             if (e.typeId != "minecraft:item") return
//             let itemComp = e.getComponent("item")
//             if (!(itemComp instanceof EntityItemComponent)) return
//             let item = itemComp.itemStack
//             let r = { e, item, brokenBlock, block, player }
//             if (brokenBlock.type.id == allowedBlocks[1]) {
//                 if (["minecraft:gravel", "minecraft:flint"].includes(item.typeId)) return transform(r)
//             }
//             if (brokenBlock.type.id == item.typeId) return transform(r)
//         }))
//     }).then((ev: (arg: EntitySpawnEvent) => void) => world.events.entitySpawn.unsubscribe(ev))
// }

// function transform({ e, item, brokenBlock, block, player }) {
//     if (item.amount == 1) e.runCommandAsync(`kill`).then(_v => {
//         const pre = prefix("hammer_")

//         let hammerList = [
//             pre + "diamond",
//             pre + "golden",
//             pre + "iron",
//             pre + "netherite",
//             pre + "stone",
//             pre + "wooden"
//         ]
//         let inventory: IEntityComponent = player.getComponent("inventory")
//         if (!(inventory instanceof EntityInventoryComponent)) return
//         let container: any = inventory.container

//         let mainhandItem = container.getItem(player.selectedSlot)

//         if (mainhandItem && hammerList.includes(mainhandItem.typeId)) {
//             switch (brokenBlock.type.id) {
//                 case MinecraftBlockTypes.cobblestone.id:
//                     return block.dimension.spawnItem(new ItemStack(ItemTypes.get("gravel"), 1), block.location)
//                 case MinecraftBlockTypes.gravel.id:
//                     return block.dimension.spawnItem(new ItemStack(ItemTypes.get("sand"), 1), block.location)
//                 case MinecraftBlockTypes.sand.id:
//                     return block.dimension.spawnItem(new ItemStack(ItemTypes.get(prefix("dust")), 1), block.location)
//                 case MinecraftBlockTypes.netherrack.id:
//                     return block.dimension.spawnItem(new ItemStack(ItemTypes.get(prefix("crushed_netherrack")), 1), block.location)
//                 case MinecraftBlockTypes.endStone.id:
//                     return block.dimension.spawnItem(new ItemStack(ItemTypes.get(prefix("crushed_end_stone")), 1), block.location)
//             }
//         }
//     })
// }

// world.events.blockBreak.subscribe(async ({ block, player, brokenBlockPermutation }) => {
//     let brokenBlock = brokenBlockPermutation
//     let t = { player, block, brokenBlock }
//     onBreakByHammer(t)
// })