import * as GameTest from '@minecraft/server-gametest'
import {
    BlockLocation,
    MinecraftBlockTypes
} from '@minecraft/server'

let blockList1 = [
    "cobblestone", "gravel", "sand", "netherrack", "endStone"
]

let m_list = ["wooden", "stone", "iron", "diamond", "netherite", "golden"]

for (let i in m_list) {
    reg(m_list[i], m_list[i] + "hammer")
}

function reg(tier, item) {
    GameTest.register("BreakTimeDiffTests", item + blockList1[0], t => {
        let k1 = false
        let k2 = false
        const bl = blockList1[0]
        const p1 = t.spawnSimulatedPlayer(new BlockLocation(0, 0, 4), `Hammer`)
        const p2 = t.spawnSimulatedPlayer(new BlockLocation(1, 0, 4), `Pickaxe`)
        t.setBlockType(MinecraftBlockTypes.barrier, new BlockLocation(1, 0, 0))
        p1.lookAtBlock(new BlockLocation(0, 1, 0))
        p2.lookAtBlock(new BlockLocation(1, 1, 0))
        p1.runCommandAsync(`give @s exnihilo:hammer_${tier}`)
        p2.runCommandAsync(`give @s ${tier}_pickaxe`)

        t.runAfterDelay(20, () => {
            let b1 = new BlockLocation(0, 1, 0)
            let b2 = new BlockLocation(1, 1, 0)
            t.setBlockType(MinecraftBlockTypes[bl], b1)
            t.setBlockType(MinecraftBlockTypes[bl], b2)
            p1.breakBlock(new BlockLocation(0, 1, 0))
            p2.breakBlock(new BlockLocation(1, 1, 0))

            t.succeedWhen(() => {
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(0, 1, 0))
                    k1 = true
                } catch { }
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(1, 1, 0))
                    k2 = true
                } catch { }
                t.assert(k1 && k2, "Two items when break block must be took same time")
            })
            t.failIf(() => {
                t.assert(k1 !== k2, "Two items when break block must be took same time")
            })
        })
    })
        .maxTicks(200)
        .structureName("m:air")
        .tag("BreakTimeDiffTests" + item)

    GameTest.register("BreakTimeDiffTests", item + blockList1[1], t => {
        let k1 = false
        let k2 = false
        const bl = blockList1[1]
        const p1 = t.spawnSimulatedPlayer(new BlockLocation(0, 0, 4), `Hammer`)
        const p2 = t.spawnSimulatedPlayer(new BlockLocation(1, 0, 4), `Shovel`)
        t.setBlockType(MinecraftBlockTypes.barrier, new BlockLocation(1, 0, 0))
        p1.lookAtBlock(new BlockLocation(0, 1, 0))
        p2.lookAtBlock(new BlockLocation(1, 1, 0))
        p1.runCommandAsync(`give @s exnihilo:hammer_${tier}`)
        p2.runCommandAsync(`give @s ${tier}_shovel`)

        t.runAfterDelay(20, () => {
            let b1 = new BlockLocation(0, 1, 0)
            let b2 = new BlockLocation(1, 1, 0)
            t.setBlockType(MinecraftBlockTypes[bl], b1)
            t.setBlockType(MinecraftBlockTypes[bl], b2)
            p1.breakBlock(new BlockLocation(0, 1, 0))
            p2.breakBlock(new BlockLocation(1, 1, 0))
            t.succeedWhen(() => {
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(0, 1, 0))
                    k1 = true
                } catch { }
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(1, 1, 0))
                    k2 = true
                } catch { }
                t.assert(k1 && k2, "Two items when break block must be took same time")
            })
            t.failIf(() => {
                t.assert(k1 !== k2, "Two items when break block must be took same time")
            })
        })

    })
        .maxTicks(200)
        .structureName("m:air")
        .tag("BreakTimeDiffTests" + item)

    GameTest.register("BreakTimeDiffTests", item + blockList1[2], t => {
        let k1 = false
        let k2 = false
        const bl = blockList1[2]
        const p1 = t.spawnSimulatedPlayer(new BlockLocation(0, 0, 4), `Hammer`)
        const p2 = t.spawnSimulatedPlayer(new BlockLocation(1, 0, 4), `Shovel`)
        t.setBlockType(MinecraftBlockTypes.barrier, new BlockLocation(1, 0, 0))
        p1.lookAtBlock(new BlockLocation(0, 1, 0))
        p2.lookAtBlock(new BlockLocation(1, 1, 0))
        p1.runCommandAsync(`give @s exnihilo:hammer_${tier}`)
        p2.runCommandAsync(`give @s ${tier}_shovel`)

        t.runAfterDelay(20, () => {
            let b1 = new BlockLocation(0, 1, 0)
            let b2 = new BlockLocation(1, 1, 0)
            t.setBlockType(MinecraftBlockTypes[bl], b1)
            t.setBlockType(MinecraftBlockTypes[bl], b2)
            p1.breakBlock(new BlockLocation(0, 1, 0))
            p2.breakBlock(new BlockLocation(1, 1, 0))
            t.succeedWhen(() => {
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(0, 1, 0))
                    k1 = true
                } catch { }
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(1, 1, 0))
                    k2 = true
                } catch { }
                t.assert(k1 && k2, "Two items when break block must be took same time")
            })
            t.failIf(() => {
                t.assert(k1 !== k2, "Two items when break block must be took same time")
            })
        })
    })
        .maxTicks(200)
        .structureName("m:air")
        .tag("BreakTimeDiffTests" + item)

    GameTest.register("BreakTimeDiffTests", item + blockList1[3], t => {
        let k1 = false
        let k2 = false
        const bl = blockList1[3]
        const p1 = t.spawnSimulatedPlayer(new BlockLocation(0, 0, 4), `Hammer`)
        const p2 = t.spawnSimulatedPlayer(new BlockLocation(1, 0, 4), `Pickaxe`)
        t.setBlockType(MinecraftBlockTypes.barrier, new BlockLocation(1, 0, 0))
        p1.lookAtBlock(new BlockLocation(0, 1, 0))
        p2.lookAtBlock(new BlockLocation(1, 1, 0))
        p1.runCommandAsync(`give @s exnihilo:hammer_${tier}`)
        p2.runCommandAsync(`give @s ${tier}_pickaxe`)

        t.runAfterDelay(20, () => {
            let b1 = new BlockLocation(0, 1, 0)
            let b2 = new BlockLocation(1, 1, 0)
            t.setBlockType(MinecraftBlockTypes[bl], b1)
            t.setBlockType(MinecraftBlockTypes[bl], b2)
            p1.breakBlock(new BlockLocation(0, 1, 0))
            p2.breakBlock(new BlockLocation(1, 1, 0))
            t.succeedWhen(() => {
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(0, 1, 0))
                    k1 = true
                } catch { }
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(1, 1, 0))
                    k2 = true
                } catch { }
                t.assert(k1 && k2, "Two items when break block must be took same time")
            })
            t.failIf(() => {
                t.assert(k1 !== k2, "Two items when break block must be took same time")
            })
        })
    })
        .maxTicks(200)
        .structureName("m:air")
        .tag("BreakTimeDiffTests" + item)

    GameTest.register("BreakTimeDiffTests", item + blockList1[4], t => {
        let k1 = false
        let k2 = false
        const bl = blockList1[4]
        const p1 = t.spawnSimulatedPlayer(new BlockLocation(0, 0, 4), `Hammer`)
        const p2 = t.spawnSimulatedPlayer(new BlockLocation(1, 0, 4), `Pickaxe`)
        t.setBlockType(MinecraftBlockTypes.barrier, new BlockLocation(1, 0, 0))
        p1.lookAtBlock(new BlockLocation(0, 1, 0))
        p2.lookAtBlock(new BlockLocation(1, 1, 0))
        p1.runCommandAsync(`give @s exnihilo:hammer_${tier}`)
        p2.runCommandAsync(`give @s ${tier}_pickaxe`)
        t.runAfterDelay(20, () => {
            let b1 = new BlockLocation(0, 1, 0)
            let b2 = new BlockLocation(1, 1, 0)
            t.setBlockType(MinecraftBlockTypes[bl], b1)
            t.setBlockType(MinecraftBlockTypes[bl], b2)
            p1.breakBlock(new BlockLocation(0, 1, 0))
            p2.breakBlock(new BlockLocation(1, 1, 0))
            t.succeedWhen(() => {
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(0, 1, 0))
                    k1 = true
                } catch { }
                try {
                    t.assertBlockPresent(MinecraftBlockTypes.air, new BlockLocation(1, 1, 0))
                    k2 = true
                } catch { }
                t.assert(k1 && k2, "Two items when break block must be took same time")
            })
            t.failIf(() => {
                t.assert(k1 !== k2, "Two items when break block must be took same time")
            })
        })
    })
        .maxTicks(200)
        .structureName("m:air")
        .tag("BreakTimeDiffTests" + item)
}

export default this